/*
 *  The Quick Sort
 */

#define SIZE 250000
#define Ptint_Status 0

//range of elements in array
#define MAX 100
#define MIN 1

#include <stdlib.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

//prototypes
void print_arr(int *);
void quick_sort(int *arr, int left, int right);
int partition(int *arr, int pivote, int left, int right);

int main (void) {

	//seed the random function
	srand (0);
	//srand( time(NULL) );

	int arr[SIZE];
	int counter;

	//init the array
	for( counter = 0; counter < SIZE; counter++) {
		arr[counter] = (rand() % MAX) + MIN;
	}

	//print the unsorted array
	if (Ptint_Status)
		print_arr(arr);

	//start timing
	clock_t start = clock();

	/*** SORTING ***/
	quick_sort(arr, 0, SIZE-1);

	//stop timing
	clock_t stop = clock();

	//print the sorted array
	if (Ptint_Status)
		print_arr(arr);


	//calculate and print the execution time in miliseconds
	double time = (double)(stop - start) * 1000 / CLOCKS_PER_SEC;
	printf("\n%f ms\n", time);

	return 0;
}

void print_arr (int *arr) {
	int counter;
	for(counter = 0; counter < SIZE; counter++) {
		printf("%d ,", arr[counter]);
	}
	printf("\n");
}

void quick_sort(int *arr, int left, int right) {
	int pivote, index;
	if(left < right) {
		pivote = right;
		index = partition(arr, pivote, left, right);
		quick_sort(arr, left, index-1);
		quick_sort(arr, index+1, right);
	}
}

int partition(int *arr, int pivote, int left, int right) {
	int value, index, counter, temp;
	value = arr[pivote];
	index = left;
	for(counter = left; counter < right; counter++) {
		if(arr[counter] < value) {
			temp = arr[counter];
			arr[counter] = arr[index];
			arr[index] = temp;
			index++;
		}
	}
	temp = arr[right];
	arr[right] = arr[index];
	arr[index] = temp;
	return index;
}
